//
// Copyright 2022 Signal Messenger, LLC
// SPDX-License-Identifier: AGPL-3.0-only
//

#import "OWSSendGiftBadgeJobRecord.h"
#import <SignalServiceKit/SignalServiceKit-Swift.h>

@interface OWSSendGiftBadgeJobRecord ()
@end

@implementation OWSSendGiftBadgeJobRecord

- (instancetype)initWithReceiptCredentialRequestContext:(NSData *)receiptCredentialRequestContext
                               receiptCredentialRequest:(NSData *)receiptCredentialRequest
                                                 amount:(NSDecimalNumber *)amount
                                           currencyCode:(NSString *)currencyCode
                              paymentIntentClientSecret:(NSString *)paymentIntentClientSecret
                                        paymentIntentId:(NSString *)paymentIntentId
                                        paymentMethodId:(NSString *)paymentMethodId
                                               threadId:(NSString *)threadId
                                            messageText:(NSString *)messageText
                                                  label:(NSString *)label
{
    self = [super initWithLabel:label];
    if (self) {
        _receiptCredentailRequestContext = receiptCredentialRequestContext;
        _receiptCredentailRequest = receiptCredentialRequest;
        _amount = amount;
        _currencyCode = currencyCode;
        _paymentIntentClientSecret = paymentIntentClientSecret;
        _boostPaymentIntentID = paymentIntentId;
        _paymentMethodId = paymentMethodId;
        _threadId = threadId;
        _messageText = messageText;
    }
    return self;
}

- (nullable instancetype)initWithCoder:(NSCoder *)coder
{
    return [super initWithCoder:coder];
}

// --- CODE GENERATION MARKER

// This snippet is generated by /Scripts/sds_codegen/sds_generate.py. Do not manually edit it, instead run
// `sds_codegen.sh`.

// clang-format off

- (instancetype)initWithGrdbId:(int64_t)grdbId
                      uniqueId:(NSString *)uniqueId
      exclusiveProcessIdentifier:(nullable NSString *)exclusiveProcessIdentifier
                    failureCount:(NSUInteger)failureCount
                           label:(NSString *)label
                          sortId:(unsigned long long)sortId
                          status:(SSKJobRecordStatus)status
                          amount:(NSDecimalNumber *)amount
            boostPaymentIntentID:(NSString *)boostPaymentIntentID
                    currencyCode:(NSString *)currencyCode
                     messageText:(NSString *)messageText
       paymentIntentClientSecret:(NSString *)paymentIntentClientSecret
                 paymentMethodId:(NSString *)paymentMethodId
        receiptCredentailRequest:(NSData *)receiptCredentailRequest
 receiptCredentailRequestContext:(NSData *)receiptCredentailRequestContext
                        threadId:(NSString *)threadId
{
    self = [super initWithGrdbId:grdbId
                        uniqueId:uniqueId
        exclusiveProcessIdentifier:exclusiveProcessIdentifier
                      failureCount:failureCount
                             label:label
                            sortId:sortId
                            status:status];

    if (!self) {
        return self;
    }

    _amount = amount;
    _boostPaymentIntentID = boostPaymentIntentID;
    _currencyCode = currencyCode;
    _messageText = messageText;
    _paymentIntentClientSecret = paymentIntentClientSecret;
    _paymentMethodId = paymentMethodId;
    _receiptCredentailRequest = receiptCredentailRequest;
    _receiptCredentailRequestContext = receiptCredentailRequestContext;
    _threadId = threadId;

    return self;
}

// clang-format on

// --- CODE GENERATION MARKER

@end
